{Parallax Propeller CC3000 WIFI}


CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000
        sockethandle = $1001
        dhcp = $8010
        connect = $1007
        keep_alive = $8200
        data_recv = $85
        nvmem_read = $91
   
VAR
  long  symbol
  word  socketget                'don't change order   
  word  recv_pnt
  word  recv_lenght
  word  socket1
  word  socket2
  word  socket3
  word  socket4   
  byte  macid[6]                 'don't change order
  byte  scaeskey[16]
  byte  scassoc[68]
OBJ
  wifi      : "Wifi Driver1.2"
  
PUB public_main
    DIRA[19..20]~~                                      'just for debugging 
    wifi.start(@socketget,@macid)                       'pointer to first word vars and first byte vars
    wifi.simple_link_start(3)                           '3=no patch
    wifi.read_buffer_size
    repeat until wifi.parse(dhcp)                       'dhcp has to be done before we can create socket
    wifi.socket(2,1,6)                                  'default numbers for tcp
    repeat until wifi.parse(sockethandle)               'wait for socket_handle to be stored
    socket1 := socketget                                'store the sockethandle to our sockets    
    wifi.connect (socket1, 3001, string("192.168.1.107"))  ' change to your local ip
    repeat until wifi.parse(connect) 
    repeat 30
      wifi.string_send (socket1, string("HELLO THERE"))
      waitcnt(cnt + (clkfreq/8))
      wifi.recv(socket1, 32)                            'max up to 32bytes at a time
      repeat until wifi.parse(data_recv)
        !OUTA[20]                                       'flash LED until data have come in
      if byte[recv_pnt]  == "H" and byte[recv_pnt+1] =="E" 'Recv_pnt points to data in spi-buffer, recv_lenght holds len
        !OUTA[19]                                       'flash LED if data starts with "HE" 
    waitcnt(cnt + (clkfreq))  
    wifi.close_socket(socket1)
    wifi.wlan_disconnect    
    repeat

   ' wifi.del_profile(255)                               'delete them all    
   ' wifi.add_profile(3,0,0, string ("aSSID"), string("aPASSWORD")) '3 = wpa2
   ' wifi.connection_policy(0,0,1)                      'autoconnect
   ' wifi.nvmem_read(6,6,0)                             'read macid (fileid 6, length 6, offset 0)
   ' repeat until wifi.parse(nvmem_read)                'wait for nwread to be done
   ' wifi.nvmem_read(12,16,0)                           'read SmartConfig AES key
   ' repeat until wifi.parse(nvmem_read)                'wait for nwread to be done
   ' if macid[0] == $08  and macid[1] == $00 and macid[2] == $28   ' most cc3000 have these 3  upper bytes
   '   OUTA[19]~~   
        